//*********************************************************
//
//    Title:  Vened
//    Genre:  Editor
//    Author: Sephiroth (Dave Burford)
//    Desc:   A tile editor.  Only for use with
//            my Venus the Fly Trap remake.
//
//*********************************************************

program vened;

CONST
    x_tiles=226;
    y_tiles=20;

    min_tile=2;
    max_tile=70;

    min_bg=501;
    max_bg=502;

GLOBAL

    struct map_x[x_tiles]
        map_y[20];
    end

    c_bg=501;

    struct data_x[x_tiles]
        data_y[20];

    end


    filet;
    fileg;

    _scroll=0;

    c_tile=2;


    gui_fnt;

    display=0;

BEGIN

    filet=load_fpg("venus/tiles.fpg");
    fileg=load_fpg("venus/v_gui.fpg");
    gui_fnt=load_fnt("venus/gui.fnt");

    set_mode(m1024x768);

    setup_map();
    main_loop();
    draw_map();
    draw_data();
    display_data();
    mouse_();
    menu_bar();
    tile_control();
    text_control();
    l_arrow();
    r_arrow();
    tile_view();

END

//*********************************************************

PROCESS setup_map()

PRIVATE

    a;b;


BEGIN



    from a=0 to x_tiles;
        from b=0 to y_tiles;
            map_x[a].map_y[b]=500;
//            map_x[a].map_y[b]=rand(2,23);
        end
    end

    from a=0 to x_tiles;
        from b=0 to y_tiles;
            data_x[a].data_y[b]=6;
//            map_x[a].map_y[b]=rand(2,23);
        end
    end



END

//*********************************************************

PROCESS main_loop()

private
    skip=0;

BEGIN

    file=filet;
    x=512; y=384; z=1000;


//    put_screen(filet,1);
    loop
        graph=1;


        scroller();
        write_int(0,20,20,0,&_scroll);
        write_int(0,20,40,0,&fps);

        if (key(_s))
            save_();
        end

        if (key(_l))
            load_();
        end

        if (key(_control))
            if (key(_d))
                skip=0;

                if (display==1)
                    display=0;
                    skip=1;
                else
                    skip=0;
                end

                if (display==0 && skip==0)
                    display=1;
                    skip=0;
                end

                while (key(_d))
                    frame;
                end
            end
        end

        frame;
        clear_screen();
        delete_text(all_text);
    end

END

//*********************************************************


PROCESS draw_map()

private

    a;b;

BEGIN
    file=filet;

    loop
    write_int(0,20,80,0,&c_bg);
    map_put(filet,1,c_bg,512,384);

    from a=0 to 32;
        from b=0 to y_tiles;
            if (a+_scroll =< x_tiles)
                if (map_x[a+_scroll].map_y[b] != 0)
                    map_put(filet,1,map_x[a+_scroll].map_y[b],a*32,b*32);
                end
            end
        end
    end
    frame;
    end
END

//*********************************************************

PROCESS draw_data()

private

    a;b;

BEGIN
    file=fileg;

    loop



    from a=0 to 32;
        from b=0 to y_tiles;
            if (a+_scroll =< x_tiles)

                //Display data numbers:

//                if (data_x[a+_scroll].data_y[b] != 0)
//                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
//                else

//                end

                if (data_x[a+_scroll].data_y[b] == 6)
                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
                end


                if (data_x[a+_scroll].data_y[b] == 7)
                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
                end

                if (data_x[a+_scroll].data_y[b] == 8)
                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
                end

                //Display badguys:

                if (data_x[a+_scroll].data_y[b] == 100)
                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
                end

                if (data_x[a+_scroll].data_y[b] == 101)
                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
                end

                if (data_x[a+_scroll].data_y[b] == 102)
                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
                end

                if (data_x[a+_scroll].data_y[b] == 103)
                    map_put(fileg,500,data_x[a+_scroll].data_y[b],a*32,b*32);
                end

            end
        end
    end
    frame;
    end
END

//*********************************************************

PROCESS display_data()

BEGIN

    x=1024/2; y=768/2; z=-1001;
    file=fileg;

    LOOP

        if (display==1)
            graph=500;
        else
            graph=0;
        end
        frame;
    end
END


//*********************************************************

PROCESS mouse_()

BEGIN

    file=fileg;
    z=-1000;
//    graph=1

    LOOP
        if (mouse.y=<21*32)
            graph=1;
            x=(mouse.x/32)*32;
            y=(mouse.y/32)*32;

            if (mouse.left)
                map_x[(mouse.x/32)+_scroll].map_y[mouse.y/32]=c_tile;
            end

            if (mouse.right)
                map_x[(mouse.x/32)+_scroll].map_y[mouse.y/32]=0;
            end

            if (key(_control))

                if (key(_0))
                    data_x[(mouse.x/32)+_scroll].data_y[mouse.y/32]=6;
                end


                if (key(_1))
                    data_x[(mouse.x/32)+_scroll].data_y[mouse.y/32]=7;
                end

                if (key(_2))
                    data_x[(mouse.x/32)+_scroll].data_y[mouse.y/32]=8;
                end

            end

            if (key(_l_shift))
                if (key(_1))
                    data_x[(mouse.x/32)+_scroll].data_y[mouse.y/32]=100;
                end

                if (key(_2))
                    data_x[(mouse.x/32)+_scroll].data_y[mouse.y/32]=101;
                end

                if (key(_3))
                    data_x[(mouse.x/32)+_scroll].data_y[mouse.y/32]=102;
                end

                if (key(_4))
                    data_x[(mouse.x/32)+_scroll].data_y[mouse.y/32]=103;
                end


            end

        ELSE
            graph=2;
            x=mouse.x;
            y=mouse.y;
        end

        frame;
    end
END

//*********************************************************

PROCESS scroller()

BEGIN

        if (key(_right))

            if (_scroll+1=>x_tiles-32)
                _scroll=x_tiles-32;
            else
                _scroll++;
            end
        end

        if (key(_left))

            if (_scroll-1=<0)
                _scroll=0;
            else
                _scroll--;
            end
        end

END

//*********************************************************

PROCESS menu_bar()

BEGIN

    file=fileg;
    graph=3;
    x=0;
    y=672;
    z=999;

    loop
        frame;
    end
END

//*********************************************************

PROCESS tile_control();

PRIVATE


BEGIN

    file=filet;

    LOOP

        x=(mouse.x/32)*32;
        y=(mouse.y/32)*32;

        if (mouse.y =< 21*32)
            graph=c_tile;
        else
            graph=0;
        end

        if (key(_plus) && c_tile+1 =< max_tile)
            c_tile=c_tile+1;
        end

        if (key(_minus) && c_tile-1 => min_tile)
            c_tile=c_tile-1;
        end

        if (key(_r_brachet) && c_bg+1 =< max_bg)
            c_bg=c_bg+1;
        end

        if (key(_l_brachet) && c_bg-1 => min_bg)
            c_bg=c_bg-1;
        end


        write_int(0,20,60,0,&c_tile);
        frame;
    end
END

//*********************************************************

PROCESS l_arrow();

PRIVATE
    m_col;

BEGIN

    file=fileg;
    graph=4;
    x=715;
    y=701;

    loop
        m_col=collision(TYPE mouse_);

        if (m_col <> 0 && mouse.left && c_tile-1 => min_tile)
            c_tile=c_tile-1;
        end


        frame;
    end
END

//*********************************************************

PROCESS r_arrow();

PRIVATE
    m_col;

BEGIN

    file=fileg;
    graph=5;
    x=821;
    y=701;


    loop
        m_col=collision(TYPE mouse_);

        if (m_col <> 0 && mouse.left && c_tile+1 =< max_tile)
            c_tile=c_tile+1;
        end


        frame;
    end
END

//*********************************************************

PROCESS text_control();

PRIVATE
    tx; ty;

BEGIN

    z=+512;

    LOOP

        if (mouse.y =< 21*32)
            tx=(mouse.x/32)+_scroll;
            ty=(mouse.y/32);
        end

        write_int(gui_fnt,186,720,4,&c_tile);
        write_int(gui_fnt,274,720,4,&mouse.x);
        write_int(gui_fnt,371,720,4,&mouse.y);
        write_int(gui_fnt,460,720,4,&tx);
        write_int(gui_fnt,538,720,4,&ty);
        frame;
    end
END

//*********************************************************

PROCESS tile_view();

BEGIN
    file=filet;
    x=69;
    y=709;

    loop
        graph=c_tile;
        frame;
    end
END

//*********************************************************

PROCESS save_();

BEGIN

   save("venus/vmap01.ven",&map_x,sizeof(map_x)+sizeof(c_bg));
   save("venus/vmap01.dat",&data_x,sizeof(data_x));

END

//*********************************************************

PROCESS load_();

BEGIN

   load("venus/vmap01.ven",&map_x);
   load("venus/vmap01.dat",&data_x);
END